# Bevy 2D Template

## Includes

- Workspace configuration w/ assets dir
- Splash screen
- [Websockets](https://lab.lcr.gr/microhacks/micro-bevy-remote-events)
- [High level audio player](https://lab.lcr.gr/microhacks/micro-bevy-musicbox)
- Basic component based follow-camera setup
- Convenience loader for assets
- Asset loading state to preload all assets
- Gitlab CI template based on [Bevy Builder](https://lab.lcr.gr/microhacks/bevy-builder)

## Usage

Write some code, ya dig?

This project is set up for a multi-crate bevy game, but will work equally well
if just using a single crate for your game. `game_core` is the location of your
entry point, assets are placed at the root of the workspace in the `assets` folder.

Update the splash screen by replacing `assets/splash.png` - it is scaled by 
default to fill the shortest screen side; you can include empty space in your 
splash image as a simple way of changing the padding. `assets/splash_sting.mp3` will
be played during the splash screen.

If you need to pre-process files to generate your assets, update the `Makefile` `assets`
command so that Gitlab CI will package them properly.

Includes websocket based multiplayer building blocks, using [micro_bevy_remote_events](https://lab.lcr.gr/microhacks/micro-bevy-remote-events)

Comes with a Gitlab CI configuration that will build releases for web, Windows and Linux.
It will also publish a Gitlab pages site with the web version automatically.

## Commands

This project uses a Makefile to define some commands to get things going.

To run the game locally on linux, get things set up by running `make setup-x11` or `make setup-wayland`
depending on your requirements.

`make run` will run the desktop version of the game, while `make run-web` will run the game in your web 
browser. The web version requires `trunk` to be installed (`cargo install trunk`).

Building the game for desktop will use a docker container to manage dependancies, but will mount
your workspace to perform the build. `make build-linux` and `make build-windows` can be run on any platform
with docker installed, perfect for cross-compilation without juggling dependencies. `make build-web`
