FROM mkaczanowski/packer-builder-arm

RUN apt-get -yqq update && \
    apt-get install -yqq git device-tree-compiler build-essential make && \
    rm -rf /var/lib/apt/lists/*

WORKDIR /deps

RUN git clone --depth=1 https://github.com/pimoroni/picade-hat.git . && \
    make

WORKDIR /build

# ENV DTBO_DEST "/build"
RUN touch "/shim.sh" && \
    chmod u+x "/shim.sh" && \
    echo '#!/usr/bin/env sh' >> "/shim.sh" && \
    echo 'cp /deps/picade.dtbo $DTBO_DEST/picade.dtbo' >> "/shim.sh" && \
    echo 'bash /entrypoint.sh $@' >> "/shim.sh"

ENTRYPOINT ["/shim.sh"]